
class ImageBox
{
	private var imageURL:String; 
	public var thumbContainerImage:MovieClip;
	public var thumbContainer:MovieClip;
	public var thumbMask:MovieClip;
	public var main:MovieClip;
	public var width:Number = 550;
	public var height:Number = 400;
	
	function ImageBox(imageURL:String, width:Number, height:Number, parent:MovieClip)
	{
		this.imageURL = imageURL;
		this.width = width;
		this.height = height; 
		
		this.thumbContainer = parent.createEmptyMovieClip("thumb", parent.getNextHighestDepth());
		this.main = thumbContainer.createEmptyMovieClip("tcic", thumbContainer.getNextHighestDepth());
		this.thumbMask = parent.createEmptyMovieClip("thumbMask", parent.getNextHighestDepth());
		this.thumbContainerImage = this.main.createEmptyMovieClip("tContainer", thumbContainer.getNextHighestDepth());
		
		this.DrawBorders();
		
		this.main.setMask(thumbMask);
	}
	public function DrawBorders(){
		this.thumbMask.clear();
		this.thumbMask.moveTo(0,0);
		this.thumbMask.beginFill(0xffffff,100);
		this.thumbMask.lineTo(this.width,0);
		this.thumbMask.lineTo(this.width,this.height);
		this.thumbMask.lineTo(0,this.height);
		this.thumbMask.lineTo(0,0);
		this.thumbMask.endFill();
		
		var borderSize:Number = 2;
		this.thumbContainer.clear();
		this.thumbContainer.moveTo(-borderSize, -borderSize);
		this.thumbContainer.beginFill(0x000000, 100);
		this.thumbContainer.lineTo(this.width + borderSize, -borderSize);
		this.thumbContainer.lineTo(this.width + borderSize, this.height + borderSize);
		this.thumbContainer.lineTo(-borderSize, this.height + borderSize);
		this.thumbContainer.lineTo(-borderSize, -borderSize);
		this.thumbContainer.endFill();
	}
	public function BeginLoad(){
		this.thumbContainerImage.loadMovie(this.imageURL);
	}
}
