import flash.filters.BlurFilter;
import flash.filters.DropShadowFilter;
/**
* A class that represents a three-dimensional version of the MovieClip class.
*/
dynamic class MovieClip3D
{
	public var base:MovieClip;
	private var drawLocation:Location3D = new Location3D(0,0,0);
	public var location:Location3D = new Location3D(0,0,0);
	public var actualLocation = new Location3D(0,0,0);
	public var finalLocation:Location3D = new Location3D(0,0,0);
	public var EaseHandler;
	public var ZIndexMultiplier:Number = 1;
	public var ZIndexAddition:Number = 0;
	public var ZBlurAddition:Number = 0;
	function MovieClip3D()
	{
		if (_root.kalleryMC == null){ 
			this.base = _root.createEmptyMovieClip("tmc" + _root.getNextHighestDepth(), _root.getNextHighestDepth());
		}else{
			this.base = _root.kalleryMC.base.createEmptyMovieClip("tmc" + _root.kalleryMC.base.getNextHighestDepth(), _root.kalleryMC.base.getNextHighestDepth());
		}
		this.EaseHandler = Easing.Spring;
		this.addProperty("X", this.getX, this.setX);
		this.addProperty("Y", this.getY, this.setY);
		this.addProperty("Z", this.getZ, this.setZ);
		this.addProperty("_X", this.get_X, this.set_X);
		this.addProperty("_Y", this.get_Y, this.set_Y);
		this.addProperty("_Z", this.get_Z, this.set_Z);
		this.addProperty("Location", this.getLocation, this.setLocation);
		this.addProperty("_Location", this.get_Location, this.set_Location);
		_root.depthCounter++;
	}
	public function getLocation():Location3D {
		return new Location3D(
			this.location.X, 
			this.location.Y,
			this.location.Z
		);
	}
	public function setLocation(value:Location3D, dontEase:Boolean):Void { 
		if (this.EaseHandler == null || dontEase){
			this.actualLocation = value;
			this.base._x = Math.round(value.To2D().X);
			this.base._y = Math.round(value.To2D().Y);
			this.base._xscale = this.base._yscale = Math.max(0, 100 - this.location.Z * 2);
			var blurAmount = Math.min(Math.max(0, (value.Z + this.ZBlurAddition + 4) / 2), 100) * 1.5;
			this.base.filters = [
				new BlurFilter(blurAmount, blurAmount, 1),
				new DropShadowFilter(5, 45, 0x000000, 50, 10, 10, 1, 1) 
			];
			this.base.swapDepths(-this.Z*ZIndexMultiplier*10 + this.ZIndexAddition)
		}else{
			this.location = value;
			this.base.parentClass = this;
			this.EaseHandler.init(this, {inertia: 0.78, endLocation: value});
			this.base.onEnterFrame = function(){
				this.parentClass.EaseHandler.performEase(this.parentClass);
			}
		}
	}
	public function set_Location(value:Location3D):Void {
		this.setLocation(value, true);
	}
	public function get_Location():Location3D { 
		return this.location;
	}
	public function getX():Number { 
		return this.Location.X;
	}
	function setX(value:Number):Void {
		this.Location = new Location3D(value, this.location.Y, this.location.Z); 
	}
	function getY():Number { 
		return this.Location.Y;
	}
	function setY(value):Void {
		this.Location = new Location3D(this.location.X, value, this.location.Z); 
	}
	function getZ():Number { 
		return this.Location.Z;
	}
	function setZ(value):Void {
		this.Location = new Location3D(this.location.X, this.location.Y, value); 
	}
	function get_X():Number {
		return this.actualLocation.X;
	}
	function set_X(value:Number):Void {
		this.setLocation(new Location3D(value, this.actualLocation.Y, this.actualLocation.Z), true);
	}
	function get_Y():Number {
		return this.actualLocation.Y;
	}
	function set_Y(value:Number):Void {
		this.setLocation(new Location3D(this.actualLocation.X, value, this.actualLocation.Z), true);
	}
	function get_Z():Number {
		return this.actualLocation.Z;
	}
	function set_Z(value:Number):Void {
		this.setLocation(new Location3D(this.actualLocation.X, this.actualLocation.Y, value), true);
	}
	
	function lineStyle(thickness:Number, rgb:Number, alpha:Number):Void{
		this.base.lineStyle(thickness,rgb,alpha);
	}
	function beginFill(rgb:Number, alpha:Number):Void{
		this.base.beginFill(rgb,alpha);
	}
	function endFill():Void{
		this.base.endFill()
	}
	function moveTo(location:Location3D):Void{
		drawLocation = location;
		this.base.moveTo(location.To2D().X, location.To2D().Y); 
	}
	function lineTo(location:Location3D):Void{
		drawLocation = location;
		this.base.lineTo(location.To2D().X, location.To2D().Y); 
	}
	public function Hide(){
		this.Z = 200; 
	}
}